#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include "unused.h"

int main(int argc, char **argv) {
	if (argc < 2) {
		puts("nohup: missing operand\nnohup [cmd]");
		return 0;
	}

	if (fork() != 0)
		return 0;

	signal(SIGHUP, SIG_IGN);

	if (isatty(STDOUT_FILENO)) {
		int fd = open("nohup.out", O_WRONLY | O_APPEND | O_CREAT, S_IRUSR | S_IWUSR);
		if (fd < 0) {
			fprintf(stderr, "nohup: nohup.out: %s\n", strerror(errno));
			return 1;
		}

		if (dup2(fd, STDOUT_FILENO) < 0)
			fprintf(stderr, "nohup: %s\n", strerror(errno));

		close(fd);
	}

	if (isatty(STDERR_FILENO))
		if (dup2(STDOUT_FILENO, STDERR_FILENO) < 0)
			fprintf(stderr, "nohup: %s\n", strerror(errno));

	argv++;
	execvp(argv[0], argv);
	fprintf(stderr, "nohup: %s: %s\n", argv[0], strerror(errno));

	return 1;
}
